1#!/bin/bash
2
3# Copyright (C) 2010 The Android Open Source Project
4#
5# Licensed under the Apache License, Version 2.0 (the "License");
6# you may not use this file except in compliance with the License.
7# You may obtain a copy of the License at
8#
9#      http://www.apache.org/licenses/LICENSE-2.0
10#
11# Unless required by applicable law or agreed to in writing, software
12# distributed under the License is distributed on an "AS IS" BASIS,
13# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14# See the License for the specific language governing permissions and
15# limitations under the License.
16
17
18# A library script to help other scripts run within an Android build environment, or while deployed
19# on a target host.  Intended to be used with the `source` bash built-in command.  Defines the
20# following environment variables:
21# JAVA_VERSION, RDBG_FLAG, TF_PATH, TRADEFED_OPTS
22#
23# It will react to the following environment variables, if they are set:
24# TF_DEBUG, TRADEFED_OPTS_FILE
25
26
27checkPath() {
28    if ! type -P "$1" &> /dev/null; then
29        >&2 echo "Unable to find $1."
30        exit
31    fi;
32}
33
34checkFile() {
35    if [ ! -f "$1" ]; then
36        >&2 echo "Unable to locate $1"
37        exit
38    fi;
39}
40
41# All to specify an alternative Java binary, other than the one on PATH
42TF_JAVA="java"
43if [ -n "${TF_JAVA_HOME}" ]; then
44  # following similar convention as JAVA_HOME
45  TF_JAVA=${TF_JAVA_HOME}/bin/java
46fi
47
48checkPath ${TF_JAVA}
49
50# check java version
51java_version_string=$(${TF_JAVA} -version 2>&1)
52JAVA_VERSION=$(echo "$java_version_string" | grep 'version [ "]\(1\.8\|9\|11\|17\|21\).*[ "]')
53if [ "${JAVA_VERSION}" == "" ]; then
54    >&2 echo "Wrong java version. 1.8, 9, 11, 17 or 21 is required. Found $java_version_string"
55    >&2 echo "PATH value:"
56    >&2 echo "$PATH"
57    if [ "${IGNORE_JAVA_VERSION_ERROR}" == "y" ]; then
58        >&2 echo "Ignoring the wrong java version error as \$IGNORE_JAVA_VERSION_ERROR is set to 'y'"
59    else
60        >&2 echo "If you want to ignore this error, set \$IGNORE_JAVA_VERSION_ERROR to 'y'"
61        exit 8
62    fi
63fi
64
65# java versions below 1.8 are not supported, java versions above 1.8 need add-opens
66JAVA_VERSION=$(echo "$java_version_string" | grep 'version [ "]1\.8.*[ "]')
67if [ "${JAVA_VERSION}" == "" ]; then
68    ADD_OPENS_FLAG="--add-opens=java.base/java.nio=ALL-UNNAMED --add-opens=java.base/sun.reflect.annotation=ALL-UNNAMED"
69fi
70
71# check debug flag and set up remote debugging
72if [ -n "${TF_DEBUG}" ]; then
73    if [ -z "${TF_DEBUG_PORT}" ]; then
74        TF_DEBUG_PORT=10088
75    fi
76    RDBG_FLAG="-agentlib:jdwp=transport=dt_socket,server=y,suspend=y,address=${TF_DEBUG_PORT}"
77fi
78
79# first try to find TF jars in same dir as this script
80CUR_DIR=$(dirname "$0")
81TF_JAR_DIR=$(dirname "$0")
82if [ -f "${CUR_DIR}/tradefed.jar" ]; then
83    TF_PATH="${CUR_DIR}/*"
84elif [ ! -z "${ANDROID_HOST_OUT}" ]; then
85    # in an Android build env, tradefed.jar should be in
86    # $ANDROID_HOST_OUT/tradefed/
87    if [ -f "${ANDROID_HOST_OUT}/tradefed/tradefed.jar" ]; then
88        # We intentionally pass the asterisk through without shell expansion
89        TF_PATH="${ANDROID_HOST_OUT}/tradefed/*"
90        TF_JAR_DIR="${ANDROID_HOST_OUT}/tradefed/"
91    fi
92fi
93
94if [ -z "${TF_PATH}" ]; then
95    >&2 echo "ERROR: Could not find tradefed jar files"
96    exit
97fi
98
99# include any host-side test jars from suite
100if [ -n "${ANDROID_HOST_OUT_TESTCASES}" ]; then
101    for folder in ${ANDROID_HOST_OUT_TESTCASES}/*; do
102        for entry in "$folder"/*; do
103            if [[ "$entry" = *".jar"* ]]; then
104                # Exclude any jar that looks like robolectric
105                if ! grep -q android/app/Application.class "$entry"; then
106                    TF_PATH=${TF_PATH}:$entry
107                fi
108            fi
109        done
110    done
111fi
112
113# set any host specific options
114# file format for file at $TRADEFED_OPTS_FILE is one line per host with the following format:
115# <hostname>=<options>
116# for example:
117# hostname.domain.com=-Djava.io.tmpdir=/location/on/disk -Danother=false ...
118# hostname2.domain.com=-Djava.io.tmpdir=/different/location -Danother=true ...
119if [ -e "${TRADEFED_OPTS_FILE}" ]; then
120    # pull the line for this host and take everything after the first =
121    export TRADEFED_OPTS=`grep "^$HOSTNAME=" "$TRADEFED_OPTS_FILE" | cut -d '=' -f 2-`
122fi
123